#include <stdio.h>
#include <stdlib.h>

#define uint8 unsigned char
#define sint8 signed char
#define sint16 signed short int
#define uint16 unsigned short int
#define uint64 unsigned long long int
#define sint64 long long int
#define sint32 int
#define uint32 unsigned int

typedef struct
{
  uint64 ZobristPedone;
  uint8 bianco_pedone_chiaro, bianco_pedone_scuro, nero_pedone_chiaro,
    nero_pedone_scuro, bianco_pedone_libero_linea, nero_pedone_libero_linea,
    bianco_patta_numero, nero_patta_numero;
  uint32 bianco_re_periglio, nero_re_periglio;
  uint32 puntos;
  uint8 bianco_pedone_linea_conteggio, nero_pedone_linea_conteggio,
    aperto_colonna_conteggio, _1;
} tipo_pedone_valu;

#define logico uint8
#define VERO 1
#define FALSO 0

#define pietra_tagliata 4
#define pietra_totale 8
#define pietra_bassa 1
#define pietra_alta 2
#define pietra_precisa 16

#define zobrist_tagliato(tr) ((tr->pietras) & pietra_tagliata)
#define zobrist_totale(tr) ((tr->pietras) & pietra_totale)
#define zobrist_preciso(tr) ((tr)->pietras & pietra_precisa)
#define ALTEZZA(x) (x - (dinamico_inizio + 1))
#define zobrist_valu_alta(tr) (tr->valu_alta)
#define zobrist_valu_bassa(tr) (tr->valu_bassa)

#define COLONNA(s) ((s) & 7)
#define TRAVERSA(s) ((s) >> 3)
#define DI(s) (((s) >> 6) & 077)
#define AI(s) ((s) & 077)

uint64 mossa_bianca_numero, mossa_nera_numero, mossa_nulla_numero;

#define chiamata_valu_piena(m) valutazione(-0x7fff0000, 0x7fff0000, m)
#define chiamata_valu_pigra(B, A, p, m) valutazione((B) - (p), (A) + (p), m)

#define bianco_in_scacco (DINAMICO->attacco_nero & bitbordo_bianco_re)
#define nero_in_scacco (DINAMICO->attacco_bianco & bitbordo_nero_re)
#define POSIZIONE1 (POSIZIONE0 + 1)
#define mossa_bianco_in_scacco (POSIZIONE1->bianco_re_scacco)
#define mossa_nero_in_scacco (POSIZIONE1->nero_re_scacco)
#define QU POSIZIONE.qu

sint16 massimo_posizionale_guadagno[0x10][07777];
logico bordo_legittimo, PARTITA_NUOVA;

uint64 MUCCHIO[1024];
int mucchio_altezzo;
#define ripetizione_verificare\
 if (DINAMICO->mossa50 >= 100) RETURN(0);\
 for (i = 4; i <= DINAMICO->mossa50 && i <= mucchio_altezzo; i += 2)\
   if (MUCCHIO[mucchio_altezzo - i] == DINAMICO->Zobrist) RETURN(0);

typedef struct
{
  uint32 zobrist;
  uint8 pietras;
  uint8 anni;
  uint8 abisso_alto, abisso_basso;
  uint16 mossa;
  sint16 valu_bassa;
  uint16 _2;
  sint16 valu_alta;
} tipo_zobrist;

tipo_zobrist *elenco_zobrist;
uint64 elenco_celare, ANNI;

typedef struct
{
  uint64 zobrist;
  sint32 valu;
  uint16 mossa;
  uint8 abisso, anni;
} tipo_zobrist_pv;
tipo_zobrist_pv elenco_zobrist_pv[0x10000];
#define elenco_celare_pv 0xfffc

#define elenco_pedone_numero (1 << 16)

typedef struct
{
  uint32 mossa;
} tipo_lista_mossa;
typedef struct
{
  uint8 qu[64];
  uint64 bitbordo[16], occupato_nero_bianco, occupato_sinistro90,
    occupato_sinistro45, occupato_retto45;
  uint8 bianco_en_mossa, bianco_re_quadretto, nero_re_quadretto, arrocco;
} tipo_posizione;
tipo_posizione POSIZIONE;

typedef struct
{
  uint64 Zobrist, ZobristPedone;
  uint32 materiale, statico, _7;
  uint8 arrocco, mossa50, en_passant, cattura;
  uint64 attacco_bianco, attacco_nero, bianco_xray, nero_xray;
  sint32 valu, valu_posizionale;
  uint16 _5, _6, uccisore_uno, uccisore_due, mossa;
  uint8 _0, _3, _4, pigro, pietras_salvas, pietras;
  uint64 bianco_re_scacco, nero_re_scacco, _1, _2, _8;
} tipo_dinamico;

#define abisso_massimo 1024
tipo_dinamico dinamico_inizio[abisso_massimo];
tipo_dinamico *DINAMICO;

#define ep_targa (DINAMICO->en_passant)

#define arrocco_bianco_oo (DINAMICO->arrocco & 0x1)
#define arrocco_bianco_ooo (DINAMICO->arrocco & 0x2)
#define arrocco_nero_oo (DINAMICO->arrocco & 0x4)
#define arrocco_nero_ooo (DINAMICO->arrocco & 0x8)

typedef struct
{
  sint16 valu;
  uint8 segno;
  uint8 pietras;
} tipo_materiale;
tipo_materiale MATERIALE[419904];

typedef enum
{ conto_occupato_bianco, conto_pedone_bianco, conto_cavallo_bianco,
    conto_re_bianco, conto_chiaro_bianco, conto_scuro_bianco,
    conto_torre_bianco, conto_donna_bianca,
  conto_occupato_nero, conto_pedone_nero, conto_cavallo_nero, conto_re_nero,
    conto_chiaro_nero, conto_scuro_nero, conto_torre_nero, conto_donna_nera
} conto_pezzos;
typedef enum
{ TRAS, cattura_gen, mossa_cattura, UCCISORE_UNO, UCCISORE_DUE,
    mossa_ordinaria, cattura_brutta,
  TRAS2, cattura_gen2, mossa_cattura2, scacco_zitto, elusione, TRAS3,
    cattura_gen3, mossa_cattura3, scacco_zitto3, guadagno
} conto_fases;
typedef enum
{ A1, B1, C1, D1, E1, F1, G1, H1, A2, B2, C2, D2, E2, F2, G2, H2,
  A3, B3, C3, D3, E3, F3, G3, H3, A4, B4, C4, D4, E4, F4, G4, H4,
  A5, B5, C5, D5, E5, F5, G5, H5, A6, B6, C6, D6, E6, F6, G6, H6,
  A7, B7, C7, D7, E7, F7, G7, H7, A8, B8, C8, D8, E8, F8, G8, H8
} conto_quadrettos;
typedef enum
{ T1, T2, T3, T4, T5, T6, T7, T8 } conto_traversas;
typedef enum
{ CA, CB, CC, CD, CE, CF, CG, CH } conto_colonnas;

sint32 statico_valu[16][64];
uint16 storia_valu[16][64];
uint64 nodo_conteggio, nodo_frequenza;
char STRING1[64], STRING2[64], STRING3[64], STRING4[64];

#define bitbordo_bianco_re POSIZIONE.bitbordo[conto_re_bianco]
#define bitbordo_bianca_donna POSIZIONE.bitbordo[conto_donna_bianca]
#define bitbordo_bianco_torre POSIZIONE.bitbordo[conto_torre_bianco]
#define bitbordo_bianco_chiaro POSIZIONE.bitbordo[conto_chiaro_bianco]
#define bitbordo_bianco_scuro POSIZIONE.bitbordo[conto_scuro_bianco]
#define bitbordo_bianco_alfiere (bitbordo_bianco_chiaro|bitbordo_bianco_scuro)
#define bitbordo_bianco_cavallo POSIZIONE.bitbordo[conto_cavallo_bianco]
#define bitbordo_bianco_pedone POSIZIONE.bitbordo[conto_pedone_bianco]
#define bitbordo_occupato_bianco POSIZIONE.bitbordo[conto_occupato_bianco]
#define bitbordo_nero_re POSIZIONE.bitbordo[conto_re_nero]
#define bitbordo_nera_donna POSIZIONE.bitbordo[conto_donna_nera]
#define bitbordo_nero_torre POSIZIONE.bitbordo[conto_torre_nero]
#define bitbordo_nero_chiaro POSIZIONE.bitbordo[conto_chiaro_nero]
#define bitbordo_nero_scuro POSIZIONE.bitbordo[conto_scuro_nero]
#define bitbordo_nero_alfiere (bitbordo_nero_chiaro|bitbordo_nero_scuro)
#define bitbordo_nero_cavallo POSIZIONE.bitbordo[conto_cavallo_nero]
#define bitbordo_nero_pedone POSIZIONE.bitbordo[conto_pedone_nero]
#define bitbordo_occupato_nero POSIZIONE.bitbordo[conto_occupato_nero]

#define turno_sinistro45 linea_turno[direzione_h1a8]
#define turno_retto45 linea_turno[direzione_a1h8]
#define turno_normale linea_turno[direzione_orizzontale]
#define turno_sinistro90 linea_turno[direzione_verticale]
#define attaco_sinistro45 linea_obscura[direzione_h1a8]
#define attaco_retto45 linea_obscura[direzione_a1h8]
#define attaco_normale linea_obscura[direzione_orizzontale]
#define attaco_sinistro90 linea_obscura[direzione_verticale]

#define ATTACO_h1a8(di)\
  attaco_sinistro45\
  [di][(POSIZIONE.occupato_sinistro45 >> turno_sinistro45[di]) & 077]
#define ATTACO_a1h8(di)\
  attaco_retto45\
  [di][(POSIZIONE.occupato_retto45 >> turno_retto45[di]) & 077]
#define ATTACO_traversa(di)\
  attaco_normale\
  [di][(POSIZIONE.occupato_nero_bianco >> turno_normale[di]) & 077]
#define ATTACO_colonna(di)\
  attaco_sinistro90\
  [di][(POSIZIONE.occupato_sinistro90 >> turno_sinistro90[di]) & 077]

#define MASSIMO(x, y) (( (x) >= (y)) ? (x) : (y))
#define MINIMO(x, y) (( (x) <= (y)) ? (x) : (y))
#define ASSOLUTO(x) (( (x) >= 0) ? (x) : -(x))
#define colonna_distacco(x, y) (ASSOLUTO(COLONNA(x) - COLONNA(y)))
#define traversa_distacco(x, y) (ASSOLUTO(TRAVERSA(x) - TRAVERSA(y)))

#define attaco_alfiere(di) (ATTACO_a1h8(di) | ATTACO_h1a8(di))
#define attaco_torre(di) (ATTACO_traversa(di) | ATTACO_colonna(di))
#define attaco_donna(di) (attaco_torre(di) | attaco_alfiere(di))

#define pietra_en_passant 030000
#define pietra_arrocco 010000
#define pietra_celare 070000
#define pietra_promozione_donna 070000
#define pietra_promozione_torre 060000
#define pietra_promozione_alfiere 050000
#define pietra_promozione_cavallo 040000
#define mossa_en_passant(x) (((x) & pietra_celare) == pietra_en_passant)
#define mossa_promozione(x) (((x) & pietra_celare) >= pietra_promozione_cavallo)
#define mossa_arrocco(x) (((x) & pietra_celare) == pietra_arrocco)
#define mossa_storia(x) (((x) & 060000) == 0)

#define direzione_orizzontale 2
#define direzione_verticale 3
#define direzione_a1h8 1
#define direzione_h1a8 0
#define direzione_malato 37
#define VALU_MATTO 30000
#define VALU_INFINITO 32750
#define MOSSA_NON 0

#include "pila.h"
#include "funzione.h"
#include "bits.h"
#include "comune.h"
