#include "RobboLito.h"

#include "sorvegliare.h"
#include "mossa_nullo.i"
#include <string.h>

#define LEGALE (POSIZIONE.bianco_en_mossa ? !nero_in_scacco : !bianco_in_scacco)
#define SCACCO (POSIZIONE.bianco_en_mossa ? bianco_in_scacco: nero_in_scacco)

void
uscita_mossa_migliore ()
{
  if (!radice_mossa)
    {
      TRASMISSIONE ("bestmove NULL\n");
      return;
    }
  fare (radice_mossa);
  chiamata_valu_piena (0);
  annullare (radice_mossa);
  TRASMISSIONE ("bestmove %s\n", mossa_notazione (radice_mossa, STRING1));
}

static char *
modificatore (int BASSO, int valu, int ALTO, char *s)
{
  s[0] = 0;
  if (valu <= BASSO)
    strcpy (s, "upperbound");
  else if (valu >= ALTO)
    strcpy (s, "lowerbound");
  else
    strcpy (s, "score");
  return s;
}

static char *
cp_mate (int valu, char *s)
{
  if (valu > VALU_MATTO - abisso_massimo)
    sprintf (s, "mate %d", (VALU_MATTO + 1 - valu) / 2);
  else if (valu < -VALU_MATTO + abisso_massimo)
    sprintf (s, "mate %d", (-VALU_MATTO - valu) / 2);
  else
    sprintf (s, "cp %d", valu);
  return s;
}

void
informazione (sint64 x, int BASSO, int valu, int ALTO)
{
  uint64 t, nps, NODOS =
    mossa_bianca_numero + mossa_nera_numero + mossa_nulla_numero;
  int sd, i, k, mossa, tras_abisso;
  tipo_dinamico *p;
  char pv[256 * 6], *q;
  tipo_zobrist_pv *tr;
  uint64 zobrist_mucchio[256];
  int cnt = 0;
  logico B;
  for (p = dinamico_inizio + 1; p->Zobrist; p++);
  sd = p - (dinamico_inizio + 1);
  memset (zobrist_mucchio, 0, 256 * sizeof (uint64));
  t = x / 1000;
  if (t == 0)
    nps = 0;
  else
    nps = NODOS / t;
  q = pv;
  zobrist_mucchio[cnt++] = DINAMICO->Zobrist;
  mossa_notazione (radice_mossa, STRING1);
  strcpy (q, STRING1);
  q += strlen (STRING1);
  strcpy (q, " ");
  q++;
  mossa = radice_mossa;
  while (mossa)
    {
      fare (mossa);
      chiamata_valu_piena (0);
      B = FALSO;
      for (i = 0; i < cnt; i++)
	if (zobrist_mucchio[i] == DINAMICO->Zobrist)
	  B = VERO;
      if (B)
	break;
      zobrist_mucchio[cnt++] = DINAMICO->Zobrist;
      mossa = 0;
      k = DINAMICO->Zobrist & elenco_celare_pv;
      tras_abisso = 0;
      for (i = 0; i < 4; i++)
	{
	  tr = elenco_zobrist_pv + (k + i);
	  if (tr->zobrist == DINAMICO->Zobrist)
	    {
	      mossa = tr->mossa;
	      break;
	    }
	}
      if (!mossa
	  || (POSIZIONE.
	      bianco_en_mossa ? !garantire_bianco (mossa) :
	      !garantire_nero (mossa)))
	break;
      if (cnt > 250)
	break;
      mossa_notazione (mossa, STRING1);
      strcpy (q, STRING1);
      q += strlen (STRING1);
      strcpy (q, " ");
      q++;
    }
  q--;
  *q = 0;
  while (DINAMICO != (dinamico_inizio + 1))
    {
      if (!DINAMICO->mossa)
	nullo_annulla ();
      else
	annullare (DINAMICO->mossa);
    }
  TRASMISSIONE
    ("info time %lld nodes %lld nps %lld %s %s depth %d seldepth %d pv %s\n",
     t, NODOS, nps * 1000, modificatore (BASSO, valu, ALTO, STRING3),
     cp_mate (valu, STRING2), radice_abisso / 2, sd, pv);
}

#include <string.h>
void
cerca ()
{
  int z;
  tipo_dinamico *p, *q;
  PARTITA_NUOVA = FALSO;
  OROLOGIO = orologio ();
  MOMENTO = clock ();
  mucchio_altezzo = -1;
  radice_mossa = radice_abisso = radice_valu = 0;
  mossa_bianca_numero = mossa_nera_numero = mossa_nulla_numero = 0;
  for (p = dinamico_inizio; p <= DINAMICO; p++)
    MUCCHIO[++mucchio_altezzo] = p->Zobrist;
  if (ANALISI)
    {
      logico RIPETIZIONE;
      for (p = dinamico_inizio; p < DINAMICO; p++)
	{
	  RIPETIZIONE = FALSO;
	  for (q = p + 2; q < DINAMICO; q += 2)
	    if (p->Zobrist == q->Zobrist)
	      {
		RIPETIZIONE = VERO;
		break;
	      }
	  if (!RIPETIZIONE)
	    MUCCHIO[p - dinamico_inizio] = 0;
	  (p + 1)->mossa = 0;
	}
    }
  memcpy (dinamico_inizio + 1, DINAMICO, sizeof (tipo_dinamico));
  memset (dinamico_inizio + 2, 0, 254 * sizeof (tipo_dinamico));
  memset (dinamico_inizio, 0, sizeof (tipo_dinamico));
  DINAMICO = dinamico_inizio + 1;
  anno_incremento ();
  radice_precedente = -VALU_MATTO;
  FACILE = FALSO;
  salto_ok = VERO;
  z = setjmp (J);
  if (!z)
    {
      if (POSIZIONE.bianco_en_mossa)
	cerca_alto_bianco ();
      else
	cerca_alto_nero ();
    }
  salto_ok = FALSO;
  abisso_precedente = radice_abisso;
  while (DINAMICO != (dinamico_inizio + 1))
    {
      if (!DINAMICO->mossa)
	nullo_annulla ();
      else
	annullare (DINAMICO->mossa);
    }
  informazione (orologio () - OROLOGIO, -32767, radice_valu, 32767);
  uscita_mossa_migliore ();
}
