
void pila_inizializzazione ();

void cerca_alt (int);
void risolvere_termine (int);
void cerca_inizializzazione (char *);
void notizia (sint64);

void valutazione (int, int, int);
void mobilita ();
void valu_zobrist_libero ();

tipo_lista_mossa *cattura_mossa (tipo_lista_mossa *, uint64);
tipo_lista_mossa *ordinaria_mossa (tipo_lista_mossa *);
tipo_lista_mossa *evasione_mossa (tipo_lista_mossa *, uint64);
void inizializzazione_cattura ();

tipo_lista_mossa *cattura_bianca (tipo_lista_mossa *, uint64);
tipo_lista_mossa *cattura_nera (tipo_lista_mossa *, uint64);
tipo_lista_mossa *ordinaria_bianca (tipo_lista_mossa *);
tipo_lista_mossa *ordinaria_nera (tipo_lista_mossa *);
void sorta_ordinaria
(tipo_lista_mossa *, tipo_lista_mossa *, uint32, uint32, uint32);

tipo_lista_mossa *scacco_zitto_bianco (tipo_lista_mossa *, uint64);
tipo_lista_mossa *scacco_zitto_nero (tipo_lista_mossa *, uint64);

tipo_lista_mossa *guadagno_bianco (tipo_lista_mossa *, int);
tipo_lista_mossa *guadagno_nero (tipo_lista_mossa *, int);
tipo_lista_mossa *evasione_nero (tipo_lista_mossa *, uint64);
tipo_lista_mossa *evasione_bianco (tipo_lista_mossa *, uint64);

void anno_incremento ();
void zobrist_libero ();
int inizializzazione_zobrist (int);

void Zobrist_basso_totale (int, int, int);
void Zobrist_alto_tagliato (int, int);
void Zobrist_basso (uint64, int, int, int);
void Zobrist_alto (uint64, int, int);
void Zobrist_preciso (int, int, int, int);

void ingresso ();

void storia_reset ();
void guadagno_reset ();

void fare (uint32);
void annullare (uint32);
void fare_bianco (uint32);
void annullare_bianco (uint32);
void fare_nero (uint32);
void annullare_nero (uint32);

void inizializzazione_valore ();

typedef struct
{
  int fase, celare, cb;
  uint32 mossa_tras, mossa;
  uint64 targa;
  tipo_lista_mossa LISTA[256];
  uint32 cattura_brutta[64];
} tipo_prossimo;
uint32 prossimo_bianco (tipo_prossimo *);
uint32 prossimo_nero (tipo_prossimo *);

logico garantire_bianco (uint32);
logico garantire_nero (uint32);

void pedone_inizializzazione ();
void valutazione_pedone (tipo_pedone_valu *);

int pv_cerca_fine_bianco (int, int, int);
int pv_cerca_fine_scacco_bianco (int, int, int);
int pv_cerca_fine_nero (int, int, int);
int pv_cerca_fine_scacco_nero (int, int, int);

void cerca_alto_bianco ();
void cerca_alto_nero ();
int nodo_superiore_bianco (int, int, int);
int nodo_superiore_nero (int, int, int);

int nodo_pv_bianco (int, int, int, int);
int nodo_pv_nero (int, int, int, int);

int escludo_bianco (int, int, uint32);
int escludo_scacco_bianco (int, int, uint32);
int escludo_nero (int, int, uint32);
int escludo_scacco_nero (int, int, uint32);

int nodo_tagliato_bianco (int VALU, int abisso);
int nodo_tagliato_nero (int VALU, int abisso);
int nodo_tagliato_scacco_bianco (int VALU, int abisso);
int nodo_tagliato_scacco_nero (int VALU, int abisso);

int nodo_totale_bianco (int VALU, int abisso);
int nodo_totale_nero (int VALU, int abisso);
int nodo_totale_scacco_bianco (int VALU, int abisso);
int nodo_totale_scacco_nero (int VALU, int abisso);

int cerca_mezzo_bianco (int VALU, int abisso);
int cerca_mezzo_nero (int VALU, int abisso);
int cerca_mezzo_scacco_bianco (int VALU, int abisso);
int cerca_mezzo_scacco_nero (int VALU, int abisso);

int cerca_fine_bianco (int VALU, int abisso);
int cerca_fine_nero (int VALU, int abisso);
int cerca_fine_scacco_bianco (int VALU, int abisso);
int cerca_fine_scacco_nero (int VALU, int abisso);

void uscita_mossa_migliore ();
void cerca ();
void informazione (sint64, int, int, int);

logico SEE_bianca (uint32 mossa);
logico SEE_nera (uint32 mossa);

char *legge_fen (char *);
void posizionale_inizializzazione (char *);

void statico_inizializzazione ();

void ERRORE (char *, ...);
void ERRORE_fen (char *, ...);
void TRASMISSIONE (char *, ...);
char *mossa_notazione (uint32, char *);
uint64 orologio ();
void bitbordo_inizializzazione ();
void partita_nuova (logico);
logico interrogativo_ingresso ();
