#include "RobboLito.h"
#include "mfa.h"

static inline void
annulla_bianco_arrocco (int ai)
{
  if (ai == G1)
    {
      bitbordo_occupato_bianco ^= F1H1;
      bitbordo_bianco_torre ^= F1H1;
      QU[F1] = 0;
      QU[H1] = conto_torre_bianco;
      POSIZIONE.occupato_nero_bianco ^= F1H1;
      POSIZIONE.occupato_sinistro90 ^= F1H1_sinistra90;
      POSIZIONE.occupato_sinistro45 ^= F1H1_sinistra45;
      POSIZIONE.occupato_retto45 ^= F1H1_retto45;
    }
  else if (ai == C1)
    {
      bitbordo_occupato_bianco ^= A1D1;
      bitbordo_bianco_torre ^= A1D1;
      QU[D1] = 0;
      QU[A1] = conto_torre_bianco;
      POSIZIONE.occupato_nero_bianco ^= A1D1;
      POSIZIONE.occupato_sinistro90 ^= A1D1_sinistra90;
      POSIZIONE.occupato_sinistro45 ^= A1D1_sinistra45;
      POSIZIONE.occupato_retto45 ^= A1D1_retto45;
    }
}

static inline void
annulla_nero_arrocco (int ai)
{
  if (ai == G8)
    {
      bitbordo_occupato_nero ^= F8H8;
      bitbordo_nero_torre ^= F8H8;
      QU[F8] = 0;
      QU[H8] = conto_torre_nero;
      POSIZIONE.occupato_nero_bianco ^= F8H8;
      POSIZIONE.occupato_sinistro90 ^= F8H8_sinistra90;
      POSIZIONE.occupato_sinistro45 ^= F8H8_sinistra45;
      POSIZIONE.occupato_retto45 ^= F8H8_retto45;
    }
  else if (ai == C8)
    {
      bitbordo_occupato_nero ^= A8D8;
      bitbordo_nero_torre ^= A8D8;
      QU[D8] = 0;
      QU[A8] = conto_torre_nero;
      POSIZIONE.occupato_nero_bianco ^= A8D8;
      POSIZIONE.occupato_sinistro90 ^= A8D8_sinistra90;
      POSIZIONE.occupato_sinistro45 ^= A8D8_sinistra45;
      POSIZIONE.occupato_retto45 ^= A8D8_retto45;
    }
}

void
annullare_bianco (uint32 mossa)
{
  int di, ai, pezzo, cattura, z;
  uint64 cel;
  di = DI (mossa);
  ai = AI (mossa);
  pezzo = QU[ai];
  POSIZIONE.bianco_en_mossa ^= 1;
  if (mossa_promozione (mossa))
    {
      POSIZIONE.bitbordo[pezzo] &= quadretto_libero[ai];
      pezzo = conto_pedone_bianco;
    }
  QU[di] = pezzo;
  QU[ai] = DINAMICO->cattura;
  if (pezzo == conto_re_bianco)
    POSIZIONE.bianco_re_quadretto = di;
  cel = quadretto_fisso[di];
  bitbordo_occupato_bianco |= cel;
  POSIZIONE.bitbordo[pezzo] |= cel;
  occupato_fisso (cel, di);
  cel = quadretto_libero[ai];
  bitbordo_occupato_bianco &= cel;
  POSIZIONE.bitbordo[pezzo] &= cel;
  cattura = DINAMICO->cattura;
  if (cattura)
    {
      cel = ~cel;
      bitbordo_occupato_nero |= cel;
      POSIZIONE.bitbordo[cattura] |= cel;
    }
  else
    {
      occupato_libero (cel, ai);
      if (mossa_arrocco (mossa))
	annulla_bianco_arrocco (ai);
      else if (mossa_en_passant (mossa))
	{
	  z = ai ^ 8;
	  QU[z] = conto_pedone_nero;
	  cel = quadretto_fisso[z];
	  bitbordo_occupato_nero |= cel;
	  bitbordo_nero_pedone |= cel;
	  occupato_fisso (cel, z);
	}
    }
  DINAMICO--;
  mucchio_altezzo--;
}

void
annullare_nero (uint32 mossa)
{
  int di, ai, pezzo, cattura, z;
  uint64 cel;
  di = DI (mossa);
  ai = AI (mossa);
  pezzo = QU[ai];
  POSIZIONE.bianco_en_mossa ^= 1;
  if (mossa_promozione (mossa))
    {
      POSIZIONE.bitbordo[pezzo] &= quadretto_libero[ai];
      pezzo = conto_pedone_nero;
    }
  QU[di] = pezzo;
  QU[ai] = DINAMICO->cattura;
  if (pezzo == conto_re_nero)
    POSIZIONE.nero_re_quadretto = di;
  cel = quadretto_fisso[di];
  bitbordo_occupato_nero |= cel;
  POSIZIONE.bitbordo[pezzo] |= cel;
  occupato_fisso (cel, di);
  cel = quadretto_libero[ai];
  bitbordo_occupato_nero &= cel;
  POSIZIONE.bitbordo[pezzo] &= cel;
  cattura = DINAMICO->cattura;
  if (cattura)
    {
      cel = ~cel;
      bitbordo_occupato_bianco |= cel;
      POSIZIONE.bitbordo[cattura] |= cel;
    }
  else
    {
      occupato_libero (cel, ai);
      if (mossa_arrocco (mossa))
	annulla_nero_arrocco (ai);
      else if (mossa_en_passant (mossa))
	{
	  z = ai ^ 8;
	  QU[z] = conto_pedone_bianco;
	  cel = quadretto_fisso[z];
	  bitbordo_occupato_bianco |= cel;
	  bitbordo_bianco_pedone |= cel;
	  occupato_fisso (cel, z);
	}
    }
  DINAMICO--;
  mucchio_altezzo--;
}

void
annullare (uint32 mossa)
{
  if (!POSIZIONE.bianco_en_mossa)
    annullare_bianco (mossa);
  else
    annullare_nero (mossa);
}
