#ifndef BUILD_nodo_pv
#define BUILD_nodo_pv
#include "RobboLito.h"
#include "storia.i"
#include "sorvegliare.h"

#include "nodo_pv.c"
#include "bianco.h"
#else
#include "nero.h"
#endif

#define RETURN(x) return(x)
int
mio_nodo_pv (int BASSO, int ALTO, int abisso, int sca)
{
  tipo_prossimo PROSSIMO[1];
  tipo_zobrist *tr;
  int mossa_buona, v, valu, k, i, tras_abisso, mossa,
    mossa_abisso = 0, mossa_tras = 0, zob_abisso;
  tipo_lista_mossa *lista, *p, *q;
  int ESTENSIONE, valu_migliore, abisso_nuovo, scacco_mossa, ai, di;
  tipo_dinamico *POSIZIONE0 = DINAMICO;

  if (ALTO < -VALU_MATTO)
    RETURN (-VALU_MATTO);
  if (BASSO > VALU_MATTO)
    RETURN (VALU_MATTO);
  if (abisso <= 1)
    {
      if (sca)
	return mio_pv_cerca_fine_scacco (BASSO, ALTO, 1);
      else
	return mio_pv_cerca_fine (BASSO, ALTO, 1);
    }
  ripetizione_verificare;
  PROSSIMO->mossa_tras = 0;
  zob_abisso = 0;
  PROSSIMO->mossa = 0;
  PROSSIMO->cb = 0;

  k = DINAMICO->Zobrist & elenco_celare;
  (POSIZIONE0 + 1)->mossa = 0;
  for (i = 0; i < 4; i++)
    {
      tr = elenco_zobrist + (k + i);
      if ((tr->zobrist ^ (DINAMICO->Zobrist >> 32)) == 0)
	{
	  tras_abisso = tr->abisso_basso;
	  mossa = tr->mossa;
	  if (mossa && tras_abisso > mossa_abisso)
	    {
	      mossa_abisso = tras_abisso;
	      (POSIZIONE0 + 1)->mossa = mossa_tras = mossa;
	    }
	  if (tr->abisso_basso > tr->abisso_alto)
	    {
	      tras_abisso = tr->abisso_basso;
	      valu = zobrist_valu_bassa (tr);
	    }
	  else
	    {
	      tras_abisso = tr->abisso_alto;
	      valu = zobrist_valu_alta (tr);
	    }
	  if (tras_abisso > zob_abisso)
	    zob_abisso = tras_abisso;
	  if (zobrist_preciso (tr) && tras_abisso >= abisso)
	    {
	      tr->anni = ANNI;
	      if (!ANALISI)
		RETURN (valu);
	    }
	}
    }

  if (!mossa_tras && abisso >= 6)
    {
      v = BASSO;
      if (abisso >= 10)
	{
	  v = mio_nodo_pv (BASSO - abisso, ALTO + abisso, abisso - 8, sca);
	  if (v > BASSO - abisso)
	    mossa_tras = (POSIZIONE0 + 1)->mossa;
	}
      if (v > BASSO - abisso)
	v = mio_nodo_pv (BASSO - abisso, ALTO + abisso, abisso - 4, sca);
      if (v > BASSO - abisso)
	mossa_tras = (POSIZIONE0 + 1)->mossa;
    }
  else if (abisso >= 10 && abisso > zob_abisso + 8)
    {
      v = mio_nodo_pv (BASSO - abisso, ALTO + abisso, abisso - 8, sca);
      if (v > BASSO - abisso)
	mossa_tras = (POSIZIONE0 + 1)->mossa;
      if (v > BASSO - abisso)
	{
	  v = mio_nodo_pv (BASSO - abisso, ALTO + abisso, abisso - 4, sca);
	  if (v > BASSO - abisso)
	    mossa_tras = (POSIZIONE0 + 1)->mossa;
	}
    }

  PROSSIMO->mossa_tras = mossa_tras;
  PROSSIMO->fase = TRAS;
  ESTENSIONE = 0;
  PROSSIMO->targa = tuo_occupato;

  int SINGOLARE = 0;
  if (sca)
    {
      lista = mio_evasione (PROSSIMO->LISTA, 0xffffffffffffffff);
      PROSSIMO->fase = elusione;
      for (p = lista - 1; p >= PROSSIMO->LISTA; p--)
	{
	  if ((p->mossa & 0x7fff) == mossa_tras)
	    p->mossa |= 0xffff0000;
	  else if (p->mossa <= (0x80 << 24))
	    {
	      if ((p->mossa & 0x7fff) == POSIZIONE0->uccisore_uno)
		p->mossa |= 0x7fff8000;
	      else if ((p->mossa & 0x7fff) == POSIZIONE0->uccisore_due)
		p->mossa |= 0x7fff0000;
	      else
		p->mossa |=
		  (p->
		   mossa & 0x7fff) |
		  (storia_valu[QU[DI (p->mossa)]][AI (p->mossa)] << 15);
	    }
	  mossa = p->mossa;
	  for (q = p + 1; q < lista; q++)
	    {
	      if (mossa < q->mossa)
		(q - 1)->mossa = q->mossa;
	      else
		break;
	    }
	  q--;
	  q->mossa = mossa;
	}
      if ((lista - PROSSIMO->LISTA) <= 1)
	SINGOLARE = 2;
      if ((lista - PROSSIMO->LISTA) == 2)
	SINGOLARE = 1;
      if ((lista - PROSSIMO->LISTA) > 2)
	SINGOLARE = 0;
    }

  if (abisso >= 16 && PROSSIMO->mossa_tras && SINGOLARE < 2
      && mio_garantire (PROSSIMO->mossa_tras))
    {
      mossa = PROSSIMO->mossa_tras;
      ai = AI (mossa);
      di = DI (mossa);
      FARE (mossa);
      chiamata_valu_piena (mossa);
      if (mossa_illegale)
	{
	  ANNULLA (mossa);
	  goto IGNORATO;
	}
      valu = -tuo_nodo_pv (-ALTO, -BASSO, abisso - 10, (mossa_scacco) != 0);
      ANNULLA (mossa);
      if (sca)
	v =
	  mio_escludo_scacco (valu - abisso / 2,
			      abisso - MINIMO (12, abisso / 2),
			      mossa & 0x7fff);
      else
	v =
	  mio_escludo (valu - abisso / 2, abisso - MINIMO (12, abisso / 2),
		       mossa & 0x7fff);
      if (v < valu - abisso / 2)
	{
	  SINGOLARE = 1;
	  if (sca)
	    v =
	      mio_escludo_scacco (valu - abisso,
				  abisso - MINIMO (12, abisso / 2),
				  mossa & 0x7fff);
	  else
	    v =
	      mio_escludo (valu - abisso, abisso - MINIMO (12, abisso / 2),
			   mossa & 0x7fff);
	  if (v < valu - abisso)
	    SINGOLARE = 2;
	}
    }
 IGNORATO:
  valu_migliore = -VALU_INFINITO;
  PROSSIMO->mossa = 0;
  PROSSIMO->cb = 0;
  mossa_buona = 0;

  while ((mossa = mio_prossimo (PROSSIMO)))
    {
      ai = AI (mossa);
      di = DI (mossa);
      if (BASSO > 0 && POSIZIONE0->mossa50 >= 2
	  && ((AI (mossa) << 6) | DI (mossa)) == (POSIZIONE0 - 1)->mossa
	  && QU[AI (mossa)] == 0)
	{
	  valu_migliore = MASSIMO (0, valu_migliore);
	  continue;
	}
      mossa &= 0x7fff;
      FARE (mossa);
      chiamata_valu_piena (mossa);
      if (mossa_illegale)
	{
	  ANNULLA (mossa);
	  continue;
	}
      scacco_mossa = (mossa_scacco != 0);
      ESTENSIONE = 0;
      if (ESTENSIONE < 2)
	{
	  if (pedone_libero_mossa (ai, TRAVERSA_SESTA (ai)))
	    ESTENSIONE = 2;
	}
      if (ESTENSIONE < 2)
	{
	  if (POSIZIONE1->cattura != 0 || scacco_mossa
	      || (sca && partita_prima))
	    ESTENSIONE = 1;
	  else if (pedone_libero_mossa (ai, TRAVERSA_QUARTA (ai)))
	    ESTENSIONE = 1;
	}
      if (PROSSIMO->mossa_tras != mossa)
	SINGOLARE = 0;
      abisso_nuovo = abisso - 2 + MASSIMO (ESTENSIONE, SINGOLARE);

      if (PROSSIMO->mossa_tras != mossa && abisso_nuovo > 1)
	{
	  if (abisso_nuovo <= 7)
	    {
	      if (scacco_mossa)
		v = -tuo_cerca_mezzo_scacco (-BASSO, abisso_nuovo);
	      else
		v = -tuo_cerca_mezzo (-BASSO, abisso_nuovo);
	    }
	  else
	    {
	      if (scacco_mossa)
		v = -tuo_nodo_tagliato_scacco (-BASSO, abisso_nuovo);
	      else
		v = -tuo_nodo_tagliato (-BASSO, abisso_nuovo);
	    }
	  if (v > BASSO)
	    v = -tuo_nodo_pv (-ALTO, -BASSO, abisso_nuovo, scacco_mossa);
	}
      else
	v = -tuo_nodo_pv (-ALTO, -BASSO, abisso_nuovo, scacco_mossa);
      ANNULLA (mossa);
      if (v <= BASSO && QU[AI (mossa)] == 0 && mossa_storia (mossa))
	STORIA_BRUTTA_pv (mossa, abisso);
      if (v <= valu_migliore)
	continue;
      valu_migliore = v;
      if (v <= BASSO)
	continue;
      BASSO = v;
      mossa_buona = mossa;
      Zobrist_basso (DINAMICO->Zobrist, mossa, abisso, v);
      if (v >= ALTO)
	{
	  if (QU[AI (mossa)] == 0 && mossa_storia (mossa))
	    STORIA_BUONA (mossa, abisso);
	  RETURN (v);
	}
    }

  mossa = mossa_buona;
  (POSIZIONE0 + 1)->mossa = mossa_buona & 0x7fff;
  if (valu_migliore == -VALU_INFINITO)
    {
      if (!sca)
	RETURN (0);
      RETURN ((POSIZIONE0 - (dinamico_inizio + 1)) - VALU_MATTO);
    }
  if (mossa)
    {
      if (QU[AI (mossa)] == 0 && mossa_storia (mossa))
	STORIA_BUONA (mossa, abisso);
      Zobrist_preciso (mossa, abisso, valu_migliore, pietra_precisa);
      RETURN (valu_migliore);
    }
  Zobrist_alto (DINAMICO->Zobrist, abisso, valu_migliore);
  RETURN (valu_migliore);
}
