
#include "RobboLito.h"
#include <string.h>
#include "sorvegliare.h"

static sint64 INVIO;
static sint64 ORA_ASSOLUTA, ORA_DESIDERATA, INCREMENTO;
static int ABISSO;
static logico ALT;

void
cerca_alt (int tr)
{
  ALT = VERO;
  if (salto_ok)
    longjmp (J, 1);
}

void
notizia (sint64 x)
{
  uint64 t, nps,
    NODOS = mossa_bianca_numero + mossa_nera_numero + mossa_nulla_numero;
  clock_t u = clock ();
  INVIO = x;
  t = x / 1000;
  if (t == 0)
    nps = 0;
  else
    nps = NODOS / t;
  u = clock () - MOMENTO;
  TRASMISSIONE ("info time %d nodes %d nps %d cpuload %d\n",
		t, NODOS, nps * 1000,
		(int) ((double) u / (double) x * 1000.0));
}

static sint64 ORA_BATTAGLIA, ORA_FACILE, ORA_ORDINARIA;

void
risolvere_termine (int d)
{
  sint64 x;
  if (!salto_ok)
    return;
  x = orologio () - OROLOGIO;
  nodo_conteggio = nodo_frequenza;
  if (d == ABISSO)
    cerca_alt (1);
  if (x - INVIO > 1000000)
    notizia (x);
  if (d >= 1 && d < 8)
    goto FINALE;
  if (x > ORA_ASSOLUTA)
    cerca_alt (1);
  if (d == 0)
    goto FINALE;
  if (!MOSSA_BRUTTA && x >= ORA_BATTAGLIA)
    cerca_alt (2);
  if (FACILE && x >= ORA_FACILE)
    cerca_alt (3);
  if (!MOSSA_BATTAGLIA && x >= ORA_ORDINARIA && !MOSSA_BRUTTA)
    cerca_alt (4);
 FINALE:
  while (interrogativo_ingresso ())
    ingresso ();
}

#define INFINITO 0xfffffffffffffff
#define STRTOK(p) p = strtok (NULL, " ")

void
cerca_inizializzazione (char *str)
{
  char *p;
  sint64 ora_bianca = INFINITO, ora_nera = INFINITO,
    incremento_bianco = 0, incremento_nero = 0, ORA, movestogo = 0;
  ABISSO = 255;
  ORA_ASSOLUTA = ORA_DESIDERATA = INFINITO;
  ALT = FALSO;
  INVIO = 0;
  nodo_conteggio = nodo_frequenza = 4096;
  p = strtok (str, " ");
  for (STRTOK (p); p != NULL; STRTOK (p))
    {
      if (!strcmp (p, "depth"))
	{
	  STRTOK (p);
	  ABISSO = MASSIMO (1, atoi (p));
	}
      else if (!strcmp (p, "movetime"))
	{
	  STRTOK (p);
	  ORA_ASSOLUTA = MASSIMO (1, atoi (p)) * 1000;
	}
      else if (!strcmp (p, "wtime"))
	{
	  STRTOK (p);
	  ora_bianca = atoll (p) * 1000;
	}
      else if (!strcmp (p, "winc"))
	{
	  STRTOK (p);
	  incremento_bianco = atoll (p) * 1000;
	}
      else if (!strcmp (p, "btime"))
	{
	  STRTOK (p);
	  ora_nera = atoll (p) * 1000;
	}
      else if (!strcmp (p, "binc"))
	{
	  STRTOK (p);
	  incremento_nero = atoll (p) * 1000;
	}
      else if (!strcmp (p, "movestogo"))
	{
	  STRTOK (p);
	  movestogo = atoi (p);
	}
      else if (!strcmp (p, "infinite"))
	continue;
      else
	ERRORE ("go string: %s", p);
    }
  ORA_BATTAGLIA = INFINITO;
  ORA_ORDINARIA = INFINITO;
  ORA_FACILE = INFINITO;
  ORA = POSIZIONE.bianco_en_mossa ? ora_bianca : ora_nera;
  if (ORA == INFINITO)
    goto FINALE;
  INCREMENTO =
    POSIZIONE.bianco_en_mossa ? incremento_bianco : incremento_nero;
  if (movestogo)
    {
      if (movestogo > 25)
	movestogo = 25;
      ORA_DESIDERATA = ORA / movestogo + INCREMENTO;
      ORA_ASSOLUTA =
	(ORA * movestogo) / (2 * movestogo - 1) - MINIMO (1000000, ORA / 10);
      if (ORA_ASSOLUTA < 5000)
	ORA_ASSOLUTA = 5000;
    }
  else
    {
      ORA_ASSOLUTA = ORA / 2 - 10000;
      if (ORA_ASSOLUTA < 5000)
	ORA_ASSOLUTA = 5000;
      ORA_DESIDERATA = ORA_ASSOLUTA / 22 + INCREMENTO;
    }
  if (ORA_DESIDERATA > ORA_ASSOLUTA)
    ORA_DESIDERATA = ORA_ASSOLUTA;
  if (ORA_DESIDERATA < 5000)
    ORA_DESIDERATA = 5000;

#if 1
  ORA_FACILE = ORA_DESIDERATA / 4;
  ORA_BATTAGLIA = ORA_DESIDERATA;
  ORA_ORDINARIA = (3 * ORA_DESIDERATA) / 4;
#else
  ORA_FACILE = ORA_DESIDERATA / 4;
  ORA_BATTAGLIA = ORA_DESIDERATA;
  ORA_ORDINARIA = (1 * ORA_DESIDERATA) / 2;
#endif

 FINALE:
  if (ORA == INFINITO)
    ANALISI = VERO;
  else
    ANALISI = FALSO;
}
